﻿ using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.Script.Serialization;
using Syncfusion.JavaScript.Web;
using System.Collections;
using System.Web.Services;
using System.Web.Script.Services;


namespace WebApplication1
{
    public partial class workproduct : System.Web.UI.Page
    {
        public List<Products> Data;
        private List<Products> product = new List<Products>();
        private List<Materials> material = new List<Materials>();




        protected void Page_Load(object sender, EventArgs e)
        {

            BindDataSource();            
            Session["DialogDataSource"] = product;
            Session["MaterialDataSource"] = material;
        }
        private void BindDataSource()
        {
            if ((List<Products>)Session["DialogDataSource"] == null)
            {
       
                product.Add(new Products(10001, "ALFKI",string.Empty));
                product.Add(new Products(10002, "ANATR",string.Empty));
                              
            }
            else
            {
                product = (List<Products>)Session["DialogDataSource"];
            }
            this.ProductGrid.DataSource = product;
            this.ProductGrid.DataBind();
  
        }


        
        protected void EditEvents_ServerEditRow(object sender, GridEventArgs e)
        {
            EditAction(e.EventType, e.Arguments["data"]);
        }

        protected void EditEvents_ServerAddRow(object sender, GridEventArgs e)
        {
            EditAction(e.EventType, e.Arguments["data"]);
        }

        protected void EditEvents_ServerDeleteRow(object sender, GridEventArgs e)
        {
            EditAction(e.EventType, e.Arguments["data"]);

        }

        protected void EditAction(string eventType, object record)
        {

            List<Products> data = Session["DialogDataSource"] as List<Products>;
            Dictionary<string, object> KeyVal = record as Dictionary<string, object>;

            if (eventType == "endEdit")
            {
                Products value = new Products();
                foreach (KeyValuePair<string, object> keyval in KeyVal)
                {

                    if (keyval.Key == "Productcode")
                    {
                        value = data.Where(d => d.Productcode == (int)keyval.Value).FirstOrDefault();
                        value.Productcode = Convert.ToInt32(keyval.Value);
                    }
                    else if (keyval.Key == "Productname")
                        value.Productname = Convert.ToString(keyval.Value);
                    else if (keyval.Key == "Type")
                        value.Type = Convert.ToString(keyval.Value);
                   
                }
            }

            else if (eventType == "endAdd")
            {
                Products newRecord = new Products();
                foreach (KeyValuePair<string, object> keyval in KeyVal)
                {

                    if (keyval.Key == "Productcode")
                        newRecord.Productcode = Convert.ToInt32(keyval.Value);
                    else if (keyval.Key == "Productname")
                        newRecord.Productname = Convert.ToString(keyval.Value);
                    else if (keyval.Key == "Type")
                        newRecord.Type = Convert.ToString(keyval.Value);

                }
                data.Insert(0, newRecord);
            }

            else if (eventType == "endDelete")
            {
                foreach (KeyValuePair<string, object> keyval in KeyVal)
                {
                    if (keyval.Key == "Productcode")
                    {
                        Products value = data.Where(d => d.Productcode == (int)keyval.Value).FirstOrDefault();
                        data.Remove(value);

                    }
                }
            }
            Session["DialogDataSource"] = data;
            this.ProductGrid.DataSource = data;
            this.ProductGrid.DataBind();
   
        }





        [Serializable]
        public class Products
        {
            public Products()
            {

            }
            public Products(int Productcode, string Productname,string Type)
            {
                this.Productcode = Productcode;
                this.Productname = Productname;
                this.Type = Type;
         
            }
            public int Productcode { get; set; }
            public string Productname { get; set; }
            public string Type { get; set; }
        }



        protected void EditMaterial_ServerEditRow(object sender, GridEventArgs e)
        {
            EditActionMaterial(e.EventType, e.Arguments["data"]);
        }

        protected void EditMaterial_ServerAddRow(object sender, GridEventArgs e)
        {
            EditActionMaterial(e.EventType, e.Arguments["data"]);
        }

        protected void EditMaterial_ServerDeleteRow(object sender, GridEventArgs e)
        {
            EditActionMaterial(e.EventType, e.Arguments["data"]);

        }



        protected void EditActionMaterial(string eventType, object record)
        {

            JavaScriptSerializer ser = new JavaScriptSerializer();
            //get currentView
            List<Materials> sel = ser.Deserialize<List<Materials>>(this.SelectRecords.Value);

            List<Materials> data = Session["MaterialDataSource"] as List<Materials>;

            Dictionary<string, object> KeyVal = record as Dictionary<string, object>;

            if (eventType == "endEdit")
            {
                Materials value = new Materials();
                foreach (KeyValuePair<string, object> keyval in KeyVal)
                {

                    if (keyval.Key == "Productcode")
                    {
                        value = data.Where(d => d.Productcode == (int)keyval.Value).FirstOrDefault();
                        value.Productcode = Convert.ToInt32(keyval.Value);
                    }
                    else if (keyval.Key == "Materialname")
                        value.Materialname = Convert.ToString(keyval.Value);
                    else if (keyval.Key == "Materialcode")
                        value.Materialcode = Convert.ToInt16(keyval.Value);


                }
            }

            else if (eventType == "endAdd")
            {
                Materials newRecord = new Materials();
                foreach (KeyValuePair<string, object> keyval in KeyVal)
                {

                    if (keyval.Key == "Materialcode")
                        newRecord.Materialcode = Convert.ToInt32(keyval.Value);
                    else if (keyval.Key == "Materialname")
                        newRecord.Materialname = Convert.ToString(keyval.Value);


                }
                data.Insert(0, newRecord);
            }

            else if (eventType == "endDelete")
            {
                foreach (KeyValuePair<string, object> keyval in KeyVal)
                {
                    if (keyval.Key == "Materialcode")
                    {
                        Materials value = data.Where(d => d.Materialcode == (int)keyval.Value).FirstOrDefault();
                        data.Remove(value);

                    }
                }
            }
            Session["MaterialDataSource"] = data;
            this.MaterialGrid.DataSource = data;
            this.MaterialGrid.DataBind();

        }





        [Serializable]
        public class Materials
        {
            public Materials()
            {

            }
            public Materials(int Materialcode, string Materialname, int Productcode, string Productname)
            {
                this.Materialcode = Materialcode;
                this.Materialname = Materialname;
                this.Productcode = Productcode;
                this.Productname = Productname;

            }
            public int Materialcode { get; set; }
            public string Materialname { get; set; }
            public int Productcode { get; set; }
            public string Productname { get; set; }
        }








        [WebMethod]
        [ScriptMethod(ResponseFormat = ResponseFormat.Json)] 
        public static List<Materials> ButtonQueries(string currentTarget, List<object> selectedRecord, int selectedIndex)
        {
            List<Materials> materials = new List<Materials>();
            //MaterialGrid.DataSource = selectedRecord;
            return materials;
        }

        protected void ProductGrid_ServerRecordClick(object sender, GridEventArgs e)
        {

            

        }







    }
}